Subject: Re: PIM over NBMA LIS

From: Pavlin Ivanov Radoslavov <[email-masked]>
Date: Mon, 15 Jan 2001 17:48:41 -0800

> I wanted to follow up with an issue that I raised at the PIM WG
> meeting regarding PIM over NBMA Logical IP Subnets (LIS).  (The
> question I raised was that the Prune-Echo might be useful in
> solving some of the problems in these topologies.  However, as
> Mark pointed out, this is only part of the puzzle.) 
> 
> The problem comes when PIM is running on a Logical IP Subnet (LIS)
> that is implemented on an NBMA network of VC's where the nodes are
> not fully meshed.  One of the most obvious examples is when a node
> transmits a Prune message to the LIS.  Depending on the normal
> underlying VC topology, this Prune message may not actual be
> delivered to all other nodes in the LIS.  This can lead to routers
> failing to override a Prune message.
> 
> Consider the following case:
> 
>                                 A
>                                / \
>                               /   \ LIS
>                              /     \
>                             B       C
>                                     |
>                                    rcv
>  
> If B sends a Prune message, it is not *necessarily* heard by C and
> hence C will not override the prune. 
> 
> There are two possible solutions to this problem:
> 
> 1) Routers on a partial mesh NBMA LIS (such as the one above) MUST
> rebroadcast all multicast messages received on one VC to all other
> VC's in the LIS.
> 
> 2) Routers on a LIS must keep track of individual Join state of
> the other routers on the LIS. 
> 
> Approach (1) has numerous problems in the area of performance as
> the router must replicate *all* packets using a pseudo broadcast
> methodology.  Furthermore, replicating arriving
> broadcast/multicast packets on one VC to all other VC's departs
> from most normal implementations (that I know of). 
> 
> Approach (2) is probably the method of choice for dealing with
> this issue.  The interface is configured to operate in a special
> NBMA Mode. When in NBMA-Mode, the OIL is populated based on
> individual PIM neighbors that have sent Joins via the NBMA
> interface instead of just by physical interface.  This effectively
> permits the PIM implementation to have awareness of the underlying
> L2 topology and handle the individual VC's as if they were p2p
> links.  
> 
> Having said all of the above, I'm not sure how or even if we want
> to try to add a short paragraph concerning this to the spec.  It
> may be that this should be implementation specific and we don't
> need anything about it in the spec.  

I may be missing some essential details (and have to admit that I
haven't given it very detailed thoughts), but woudn't be sufficient
if A considers the virtual A-B and A-C links as separate (from
PIM-SM point of view) interfaces?
Then you just need a simple implementation layer/glue that maps the
PIM-SM virtual interfaces to the same physical interface with some
simple rules such as : "oif(phyint1) = UNION(oif(vif1), oif(vif2))",
where vif1 and vif2 map to the same phyint1.

With other words, it seems to me that this is an implementation
issue and there is no need for PIM-SM to do anything special?

Pavlin

> 
> I'll let you be the judges on this. At least I've made you aware
> of some real world topologies that may or may not be covered by
> the current spec.
> 
> Beau Williamson

---

From: Isidor Kouvelas <[email-masked]>
Date: Mon, 15 Jan 2001 18:14:29 -0800

In message <[email-masked]>,
>issue and there is no need for PIM-SM to do anything special?

Yes I completely agree with Pavlin.

thanks
I